#include <config.h>

#include "antilink.h"
#include "mime.h"
#include "mime_p.h"
#ifdef WITH_DMALLOC
# include <dmalloc.h>
#endif

const char *find_mime_type(const char * const filename)
{
    register const Mime *mime_pnt = mime_table;
    register const char *extpoint;
    const char *type = NULL;
    
    do {
        if ((extpoint = strrchr(filename, *mime_pnt->ext)) != NULL
            && strcasecmp(extpoint, mime_pnt->ext) == 0) {
            break;
        }
        mime_pnt++;
    } while (mime_pnt->ext != NULL);
    
    return type;
}
